diff --git a/drivers/common/mlx5/linux/mlx5_common_os.c b/drivers/common/mlx5/linux/mlx5_common_os.c
index 2ebb8ac8b6e5..7a7aadffa602 100644
--- a/drivers/common/mlx5/linux/mlx5_common_os.c
+++ b/drivers/common/mlx5/linux/mlx5_common_os.c
@@ -234,7 +234,7 @@ mlx5_get_ifname_sysfs(const char *ibdev_path, char *ifname)
 /**
  * Suffix RTE_EAL_PMD_PATH with "-glue".
  *
- * This function performs a sanity check on RTE_EAL_PMD_PATH before
+ * This function performs a check on RTE_EAL_PMD_PATH before
  * suffixing its last component.
  *
  * @param buf[out]
diff --git a/drivers/net/mlx4/mlx4.c b/drivers/net/mlx4/mlx4.c
index a54016f4a235..e3048d5b6ec0 100644
--- a/drivers/net/mlx4/mlx4.c
+++ b/drivers/net/mlx4/mlx4.c
@@ -1206,7 +1206,7 @@ static struct rte_pci_driver mlx4_driver = {
 /**
  * Suffix RTE_EAL_PMD_PATH with "-glue".
  *
- * This function performs a sanity check on RTE_EAL_PMD_PATH before
+ * This function performs a check on RTE_EAL_PMD_PATH before
  * suffixing its last component.
  *
  * @param buf[out]
diff --git a/drivers/net/mlx4/mlx4_flow.c b/drivers/net/mlx4/mlx4_flow.c
index 8ef9fd2db44e..25b185d8710c 100644
--- a/drivers/net/mlx4/mlx4_flow.c
+++ b/drivers/net/mlx4/mlx4_flow.c
@@ -514,7 +514,7 @@ mlx4_flow_merge_tcp(struct rte_flow *flow,
 }
 
 /**
- * Perform basic sanity checks on a pattern item.
+ * Perform basic checks on a pattern item.
  *
  * @param[in] item
  *   Item specification.
@@ -730,7 +730,7 @@ mlx4_flow_prepare(struct mlx4_priv *priv,
 			goto exit_item_not_supported;
 		proc = next;
 		/*
-		 * Perform basic sanity checks only once, while handle is
+		 * Perform basic checks only once, while handle is
 		 * not allocated.
 		 */
 		if (flow == &temp) {
@@ -799,7 +799,7 @@ mlx4_flow_prepare(struct mlx4_priv *priv,
 				rss_key = mlx4_rss_hash_key_default;
 				rss_key_len = MLX4_RSS_HASH_KEY_SIZE;
 			}
-			/* Sanity checks. */
+			/* Input checks. */
 			for (i = 0; i < rss->queue_num; ++i)
 				if (rss->queue[i] >=
 				    ETH_DEV(priv)->data->nb_rx_queues)
diff --git a/drivers/net/mlx5/mlx5_flow_dv.c b/drivers/net/mlx5/mlx5_flow_dv.c
index a8dd9920e6a4..7c21a9d6e91f 100644
--- a/drivers/net/mlx5/mlx5_flow_dv.c
+++ b/drivers/net/mlx5/mlx5_flow_dv.c
@@ -8753,7 +8753,7 @@ flow_dv_prepare(struct rte_eth_dev *dev,
 
 #ifdef RTE_LIBRTE_MLX5_DEBUG
 /**
- * Sanity check for match mask and value. Similar to check_valid_spec() in
+ * Check for match mask and value. Similar to check_valid_spec() in
  * kernel driver. If unmasked bit is present in value, it returns failure.
  *
  * @param match_mask
diff --git a/drivers/net/mlx5/mlx5_flow_hw.c b/drivers/net/mlx5/mlx5_flow_hw.c
index 5395969eb07e..0e7baa7c1a6e 100644
--- a/drivers/net/mlx5/mlx5_flow_hw.c
+++ b/drivers/net/mlx5/mlx5_flow_hw.c
@@ -6008,11 +6008,10 @@ flow_hw_tx_tag_regc_mask(struct rte_eth_dev *dev)
 	struct mlx5_priv *priv = dev->data->dev_private;
 	uint32_t mask = priv->sh->dv_regc0_mask;
 
-	/* Mask is verified during device initialization. Sanity checking here. */
+	/* Mask is verified during device initialization. */
 	MLX5_ASSERT(mask != 0);
 	/*
 	 * Availability of sufficient number of bits in REG_C_0 is verified on initialization.
-	 * Sanity checking here.
 	 */
 	MLX5_ASSERT(__builtin_popcount(mask) >= __builtin_popcount(priv->vport_meta_mask));
 	return mask;
@@ -6024,12 +6023,11 @@ flow_hw_tx_tag_regc_value(struct rte_eth_dev *dev)
 	struct mlx5_priv *priv = dev->data->dev_private;
 	uint32_t tag;
 
-	/* Mask is verified during device initialization. Sanity checking here. */
+	/* Mask is verified during device initialization. */
 	MLX5_ASSERT(priv->vport_meta_mask != 0);
 	tag = priv->vport_meta_tag >> (rte_bsf32(priv->vport_meta_mask));
 	/*
 	 * Availability of sufficient number of bits in REG_C_0 is verified on initialization.
-	 * Sanity checking here.
 	 */
 	MLX5_ASSERT((tag & priv->sh->dv_regc0_mask) == tag);
 	return tag;
diff --git a/drivers/net/mlx5/mlx5_rxq.c b/drivers/net/mlx5/mlx5_rxq.c
index 8ef7860e161e..d18a46dff212 100644
--- a/drivers/net/mlx5/mlx5_rxq.c
+++ b/drivers/net/mlx5/mlx5_rxq.c
@@ -1442,7 +1442,7 @@ mlx5_mprq_alloc_mp(struct rte_eth_dev *dev)
 	desc *= 4;
 	obj_num = desc + MLX5_MPRQ_MP_CACHE_SZ * n_ibv;
 	/*
-	 * rte_mempool_create_empty() has sanity check to refuse large cache
+	 * rte_mempool_create_empty() has basic check to refuse large cache
 	 * size compared to the number of elements.
 	 * CACHE_FLUSHTHRESH_MULTIPLIER is defined in a C file, so using a
 	 * constant number 2 instead.
diff --git a/drivers/net/mlx5/mlx5_rxtx_vec.h b/drivers/net/mlx5/mlx5_rxtx_vec.h
index 77c3f4efa019..f8376f2b55b4 100644
--- a/drivers/net/mlx5/mlx5_rxtx_vec.h
+++ b/drivers/net/mlx5/mlx5_rxtx_vec.h
@@ -21,7 +21,7 @@
 	 RTE_ETH_TX_OFFLOAD_OUTER_IPV4_CKSUM)
 
 /*
- * Compile time sanity check for vectorized functions.
+ * Compile time checks for vectorized functions.
  */
 
 #define S_ASSERT_RTE_MBUF(s) \